;=======================eje3.ASM===================11-07-97=========
;Programa para tarjeta 5i-30r-1
;Enciende los tres Reles de salida con E0 y apaga los tres Reles con E1
;Cuando los reles encienden con un pequeo tiempo de retraso de 5seg: RB7..RB6..RB5
;Al desenergizar tambien con un retrazo de 2 seg pero RB5..RB6..RB7
;Colocar Jumper J1 a J5 en 1
;-------------------------------------------------------------------------
w               equ     0            
f               equ     1

rp0		equ	5	;status equate	

E0		equ		0x0
E1		equ		0x1
E2		equ		0x2
E3		equ		0x3
E4		equ		0x4
E5		equ		0x5
;----------------------------------------------------------------------------
;               cpu equates (memory map)
status		equ  	0x03
porta		equ	0x05
portb           equ     0x06

rcount		equ	0x0f	;registro mas interno de paus_1s
scount		equ	0x10	;registro medio de paus_1s
tcount		equ	0x11	;registro externo de paus_1s
ucount		equ	0x12	;registro de npaus_1s

trisa		equ	0x85
trisb		equ	0x86
;-------------------------------------------------------------------------
	#DEFINE		EnciendeRB7	bsf	portb,7
	#DEFINE		EnciendeRB6 	bsf	portb,6
	#DEFINE		EnciendeRB5 	bsf	portb,5

	#DEFINE		ApagaRB7	bcf	portb,7
	#DEFINE		ApagaRB6	bcf	portb,6
	#DEFINE		ApagaRB5	bcf	portb,5
;-------------------------------------------------------------------------
;MACROS
		variable	seg=0

Segundos	macro		seg
		movlw		seg
		movwf		ucount
		call		npaus_1s		
		endm
;----------------------------------------------------------------------------
Programa
                org             0x000
						
start           bsf	status,rp0	;cambia al banck1
		movlw	b'00000001'
		movwf	trisa		;porta todas salidas
		movlw	b'00011111'
    		movwf	trisb
		bcf	status,rp0	;regresa al banck0
						
                clrf            portb   ;apaga puerto B
		clrf		porta	;apaga puerto A


ChecaBotones

ChecaE0Activado
		btfsc		portb,E0	;E0 esta activado ?	
		goto 		ChecaE0Activado	;No
		
                EnciendeRB7		   	;Enciende RB7
		Segundos	0x5
                EnciendeRB6
		Segundos	0x5
                EnciendeRB5
		Segundos	0x5

ChecaE0Desactivado
		btfss		portb,E0	;E0 esta desactivado ?
		goto		ChecaE0Desactivado


ChecaE1Activado
		btfsc		portb,E1	
		goto		ChecaE1Activado

		ApagaRB5
		Segundos	0x2
		ApagaRB6
		Segundos	0x2
		ApagaRB7
		Segundos	0x2
ChecaE1Desactivado
		btfss		portb,E1
		goto		ChecaE1Desactivado


		
		goto		ChecaBotones

;----------------------------------------------------------------------------
;SUBRRITINAS
;----------------------------------------------------------------------------
;paus_1s es una pausa de 1 segundo
paus_1s		movlw	0x0a		;carga
		movwf	tcount		;tcount
loads		movlw   0x82            ;carga
                movwf   scount          ;scount
loadr           movlw   0xff            ;carga
                movwf   rcount          ;rcount
decr            decfsz  rcount,f        ;decrement r
                goto    decr            ;again
                decfsz  scount,f        ;decrement s
                goto    loadr           ;again
		decfsz	tcount		;decrement t
		goto	loads		;again
                return                  ;done

;----------------------------------------------------------------------------
;npause_1s repite 1s las veces que contenda el registro ucount
;antes de entrar cargar el registro pcount con el numero deceado
npaus_1s        call	paus_1s
		decfsz	ucount,f
		goto	npaus_1s
		return

;----------------------------------------------------------------------------
		end
;----------------------------------------------------------------------------



